//+------------------------------------------------------------------+
//|                                 SwamiSuperSmoother_v1.0 600+.mq4 |
//|                                Copyright  2016, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
#property link      "http://newdigital-world.com/forum.php"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrSteelBlue
#property indicator_color2  clrChocolate
#property indicator_color3  clrNONE
#property indicator_color4  clrNONE

#property indicator_width1  2
#property indicator_width2  2  

#define pi 3.14159265358979323846

enum ENUM_PRICE
{
   close,               // Close
   open,                // Open
   high,                // High
   low,                 // Low
   median,              // Median
   typical,             // Typical
   weightedClose,       // Weighted Close
   heikenAshiClose,     // Heiken Ashi Close
   heikenAshiOpen,      // Heiken Ashi Open
   heikenAshiHigh,      // Heiken Ashi High   
   heikenAshiLow,       // Heiken Ashi Low
   heikenAshiMedian,    // Heiken Ashi Median
   heikenAshiTypical,   // Heiken Ashi Typical
   heikenAshiWeighted   // Heiken Ashi Weighted Close   
};

enum ENUM_VMODE
{
   halftone,            // original with haltones
   trend                // trend (bicolor)
};

enum ENUM_SCALE
{
   ehlers,              // by J.Ehlers
   norm                 // 0...100
};

//---- 
input ENUM_VMODE  VisualMode        =         0;   // Visual Mode
input ENUM_PRICE  Price             =         0;   // Applied to
input int         StartLength       =        10;
input int         EndLength         =       100; 
input int         SampleLength      =        21;   // 0-off
input color       UpTrendColor      =   clrLime;   
input color       DnTrendColor      =    clrRed; 
input color       FlatColor         = clrYellow;
input string      UniqueName        = "SuperSmu";
input ENUM_SCALE  ScaleMode         =         0;   //Scale Mode
input int         SwamiBars         =       100;

//---- 
double   superSmoother[];
double   sumSuperSmoother[];
double   upValue[];
double   loValue[];
double   iPrice[];
//----
int      sampleLength, draw_begin, win, upLineR, upLineG, upLineB, dnLineR, dnLineG, dnLineB, flLineR, flLineG, flLineB, swamisize, trend[][2]; 
string   IndicatorName, short_name;
double   swamisupersmu[], supersmoother[][2], fuzzWidth, maxValue, minValue;
datetime prevtime;        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- 
   colorToRGB(UpTrendColor,upLineR,upLineG,upLineB);
   colorToRGB(DnTrendColor,dnLineR,dnLineG,dnLineB);
   colorToRGB(FlatColor   ,flLineR,flLineG,flLineB);
//---- 
   IndicatorName = WindowExpertName(); 
   short_name = IndicatorName+"("+VisualMode+","+Price+","+StartLength+","+EndLength+","+SampleLength+","+ScaleMode+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"SwamiSuperSmoother("+SampleLength+")");
   SetIndexLabel(1,"SummarySuperSmoother");
//---- 
   IndicatorBuffers(5);
   SetIndexBuffer(0,   superSmoother); SetIndexStyle(0,DRAW_LINE); SetIndexDrawBegin(0,EndLength);
   SetIndexBuffer(1,sumSuperSmoother); SetIndexStyle(1,DRAW_LINE); SetIndexDrawBegin(1,EndLength);
   SetIndexBuffer(2,         loValue); SetIndexStyle(2,DRAW_LINE); SetIndexDrawBegin(2,EndLength);
   SetIndexBuffer(3,         upValue); SetIndexStyle(3,DRAW_LINE); SetIndexDrawBegin(3,EndLength);
   SetIndexBuffer(4,          iPrice);
//----
   swamisize = EndLength - StartLength + 1;
   
   ArrayResize(array        ,swamisize);
   ArrayResize(smuprevtime  ,swamisize);
   ArrayResize(supersmoother,swamisize);
   ArrayResize(swamisupersmu,swamisize);
   ArrayResize(trend        ,swamisize);
   
   sampleLength = SampleLength;
   
   if(SampleLength > 0)
   {
   if(SampleLength < StartLength) sampleLength = StartLength; 
   if(SampleLength > EndLength  ) sampleLength = EndLength;
   }
   
   if(ScaleMode == 0) {fuzzWidth = 1; maxValue = EndLength; minValue = StartLength;}
   else {fuzzWidth = 100.0/(EndLength-StartLength); maxValue = 100; minValue = 0;}
   
   Print("flat=",FlatColor);
   
   return(0);
}

//----  
void deinit()
{ 
   ObjectsDeleteAll(win,OBJ_RECTANGLE);  
   
   return;
}
//+------------------------------------------------------------------+
//| SwamiSuperSmoother_v1.0 600+                                     |
//+------------------------------------------------------------------+
int start()
{
   int   shift, limit, Color1, Color2, Color3, counted_bars = IndicatorCounted();
   
   win = WindowFind(short_name); 
//---- 
   if(counted_bars > 0) limit = Bars - counted_bars - 1;
   if(counted_bars < 0) return(0);
   if(counted_bars < 1)
   { 
   limit = Bars - 1;   
   for(int i=limit;i>=0;i--) {superSmoother[i] = EMPTY_VALUE; sumSuperSmoother[i] = EMPTY_VALUE;}
   ObjectsDeleteAll(win,OBJ_RECTANGLE);  
   }   
         
   for(shift=limit; shift>=0; shift--)
   {   
      if(prevtime != Time[shift]) 
      {
      for(i=0;i<swamisize;i++) {supersmoother[i][1] = supersmoother[i][0]; trend[i][1] = trend[i][0];}
      prevtime = Time[shift];
      }
      
   loValue[shift] = minValue;
   upValue[shift] = maxValue;
   
      if((int)Price <= 6) iPrice[shift] = iMA(NULL,0,1,0,0,(int)Price,shift);   
      else
      if((int)Price > 6 && (int)Price <= 13) iPrice[shift] = HeikenAshi((int)Price-7,Bars,shift);
   
   double sum = 0, swamisum = 0; 
    
      for(i=0;i<swamisize;i++) 
      {
      supersmoother[i][0] = SuperSmuOnArray(i,(iPrice[shift] + iPrice[shift+1])/2,StartLength+i,Bars,shift); 
              
      trend[i][0] = trend[i][1];
      
      if(VisualMode == 1) int trendValue = 0; else trendValue =-1;
          
      if(supersmoother[i][0] > supersmoother[i][1]) trend[i][0] = 1;
      if(supersmoother[i][0] < supersmoother[i][1]) trend[i][0] = trendValue;
            
      sum += trend[i][0];
      
      if(VisualMode == 1) double compValue = trend[i][0]; else compValue = (sum/(i + 1)+1)/2.0; 
              
      swamisupersmu[i] = compValue; 
      
      if(swamisupersmu[i] > 1) swamisupersmu[i] = 1;
      if(swamisupersmu[i] < 0) swamisupersmu[i] = 0; 
         
      swamisum += swamisupersmu[i];
      }   
      
      if(ScaleMode == 0)
      {
      if(sampleLength > 0) superSmoother[shift] = StartLength + (swamisize - 1)*swamisupersmu[sampleLength-StartLength]; 
      sumSuperSmoother[shift] = StartLength + (swamisize - 1)*swamisum/swamisize;
      }
      else
      {
      if(SampleLength > 0) superSmoother[shift] = 100*swamisupersmu[sampleLength-StartLength]; 
      sumSuperSmoother[shift] = 100*swamisum/swamisize;
      }
   
   if((SwamiBars > 0 && shift < SwamiBars)||(SwamiBars == 0 && shift < Bars-1)) 
      for(i=0;i<swamisize;i++)
      {
	      if(FlatColor == EMPTY_VALUE) 
	      {
	      Color1 = dnLineR + swamisupersmu[i]*(upLineR - dnLineR);
         Color2 = dnLineG + swamisupersmu[i]*(upLineG - dnLineG);
         Color3 = dnLineB + swamisupersmu[i]*(upLineB - dnLineB);
	      }
	      else
	      {
            if(swamisupersmu[i] >= 0.5)
            {
            Color1 = upLineR + 2*(1 - swamisupersmu[i])*(flLineR - upLineR);
            Color2 = upLineG + 2*(1 - swamisupersmu[i])*(flLineG - upLineG);
            Color3 = upLineB + 2*(1 - swamisupersmu[i])*(flLineB - upLineB);
            }
            else 
            if(swamisupersmu[i] < 0.5)
            {
            Color1 = dnLineR + 2*swamisupersmu[i]*(flLineR - dnLineR);
            Color2 = dnLineG + 2*swamisupersmu[i]*(flLineG - dnLineG);
            Color3 = dnLineB + 2*swamisupersmu[i]*(flLineB - dnLineB);
            }
         }            
            
      
      if(ScaleMode == 0) double value = i+StartLength; else value = i*fuzzWidth; 
         
      string text = UniqueName+"("+(i+StartLength)+") "+win+" "+TimeToStr(Time[shift]); 
      
      Plot(value, text, rgbToColor(Color1, Color2, Color3),fuzzWidth,shift);
      }
   }

   WindowRedraw();
   
   return(0);
}

//-----
// SuperSmoother filter
double   array[][3];
datetime smuprevtime[];

double SuperSmuOnArray(int index,double price,int per,int cbars,int bar)
{
   if(smuprevtime[index] != Time[bar])
   {
   array[index][2] = array[index][1];
   array[index][1] = array[index][0];
   smuprevtime[index] = Time[bar];
   }
   
   double a  = MathExp(-1.414*pi/per);
   double b  = 2*a*MathCos(1.414*pi/per);
   double c2 = b;
   double c3 = -a*a;
   double c1 = 1 - c2 - c3;
   
   if(bar < cbars - 7) array[index][0] = c1*price + c2*array[index][1] + c3*array[index][2];
   else array[index][0] = price;
   
   return(array[index][0]);
}
   

// HeikenAshi Price
double   haClose[2], haOpen[2], haHigh[2], haLow[2];
datetime prevhatime;  

double HeikenAshi(int price,int cbars,int bar)
{ 
   if(prevhatime != Time[bar])
   {
   haClose[1] = haClose[0];
   haOpen [1] = haOpen [0];
   haHigh [1] = haHigh [0];
   haLow  [1] = haLow  [0];
   prevhatime = Time[bar];
   }
   
   if(bar == cbars - 1) 
   {
   haClose[0] = Close[bar];
   haOpen [0] = Open [bar];
   haHigh [0] = High [bar];
   haLow  [0] = Low  [bar];
   }
   else
   {
   haClose[0] = (Open[bar] + High[bar] + Low[bar] + Close[bar])/4;
   haOpen [0] = (haOpen[1] + haClose[1])/2;
   haHigh [0] = MathMax(High[bar],MathMax(haOpen[0],haClose[0]));
   haLow  [0] = MathMin(Low [bar],MathMin(haOpen[0],haClose[0]));
   }
   
   switch(price)
   {
   case  0: return(haClose[0]); break;
   case  1: return(haOpen [0]); break;
   case  2: return(haHigh [0]); break;
   case  3: return(haLow  [0]); break;
   case  4: return((haHigh[0] + haLow[0])/2); break;
   case  5: return((haHigh[0] + haLow[0] +   haClose[0])/3); break;
   case  6: return((haHigh[0] + haLow[0] + 2*haClose[0])/4); break;
   default: return(haClose[0]); break;
   }
}



int rgbToColor(int R, int G, int B)
{
   return (256*(256*B + G) + R);
}

void colorToRGB(color clr,int& R, int& G, int& B)
{
   R = clr&0x000000FF;
   G = (clr>>8)&0x000000FF;
   B = (clr>>16)&0x000000FF; 
}

void Plot(double value,string name,color clr,double width,int bar)
{   
   ObjectDelete(name); 
   ObjectCreate(name,OBJ_RECTANGLE,win,Time[bar+1],value-0.5*width,Time[bar],value+0.5*width);
   ObjectSet(name,OBJPROP_COLOR,clr);
}

