//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2

extern int    LookBack = 32;
extern int    Median   = 16;
extern int    Price    = PRICE_MEDIAN;
extern double Smooth   = 10;

double LagRsi[];
double LagRsida[];
double LagRsidb[];
double LagFil[];
double Diff[];
double Slope[];
double sortDiff[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,LagRsi);
   SetIndexBuffer(1,LagRsida);
   SetIndexBuffer(2,LagRsidb);
   SetIndexBuffer(3,LagFil);
   SetIndexBuffer(4,Diff);
   SetIndexBuffer(5,Slope);
      ArrayResize(sortDiff,Median);
   return (0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         
         //
         //
         //
         //
         //

   if (Slope[limit]==-1) CleanPoint(limit,LagRsida,LagRsidb);
   for (int i=limit; i>=0; i--)   
   {
      double price   = iMA(NULL,0,1,0,MODE_SMA,Price,i);
             Diff[i] = MathAbs(price - LagFil[i+1]);
      double hi    = Diff[ArrayMaximum(Diff,LookBack,i)];
      double lo    = Diff[ArrayMinimum(Diff,LookBack,i)];
      double alpha = 0;
         if (hi!=lo)    
         {
            for (int j=0; j<Median; j++) sortDiff[j] = (Diff[i+j]-lo)/(hi-lo);
               ArraySort(sortDiff,WHOLE_ARRAY,0,MODE_ASCEND);
                  if (MathMod(Median,2.0) != 0)   alpha = sortDiff[Median/2];         
                  else                            alpha = (sortDiff[Median/2]+sortDiff[(Median/2)-1])/2;
         }
      LagFil[i]   = iLaGuerreFilter(price, 1.0-alpha, i, 0);         
      LagRsi[i]   = iSsm(iLaGuerreRsi(price, 1.0-alpha, i, 0),Smooth,i);
      LagRsida[i] = EMPTY_VALUE;
      LagRsidb[i] = EMPTY_VALUE;
      Slope[i]    = Slope[i+1];
         if (LagRsi[i]>LagRsi[i+1]) Slope[i] =  1;
         if (LagRsi[i]<LagRsi[i+1]) Slope[i] = -1;
         if (Slope[i] == -1) PlotPoint(i,LagRsida,LagRsidb,LagRsi);
   }
   return (0);   
}


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workLagFil[][4];
double iLaGuerreFilter(double price, double gamma, int i, int instanceNo=0)
{
   if (ArrayRange(workLagFil,0)!=Bars) ArrayResize(workLagFil,Bars); i=Bars-i-1; instanceNo*=4;
   if (gamma<=0) return(price);

   //
   //
   //
   //
   //
      
   workLagFil[i][instanceNo+0] = (1.0 - gamma)*price                                                + gamma*workLagFil[i-1][instanceNo+0];
	workLagFil[i][instanceNo+1] = -gamma*workLagFil[i][instanceNo+0] + workLagFil[i-1][instanceNo+0] + gamma*workLagFil[i-1][instanceNo+1];
	workLagFil[i][instanceNo+2] = -gamma*workLagFil[i][instanceNo+1] + workLagFil[i-1][instanceNo+1] + gamma*workLagFil[i-1][instanceNo+2];
	workLagFil[i][instanceNo+3] = -gamma*workLagFil[i][instanceNo+2] + workLagFil[i-1][instanceNo+2] + gamma*workLagFil[i-1][instanceNo+3];

   //
   //
   //
   //
   //
 
   return((workLagFil[i][instanceNo+0]+2.0*workLagFil[i][instanceNo+1]+2.0*workLagFil[i][instanceNo+2]+workLagFil[i][instanceNo+3])/6.0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workLagRsi[][4];
double iLaGuerreRsi(double price, double gamma, int i, int instanceNo=0)
{
   if (gamma<=0) return(price);
   if (ArrayRange(workLagRsi,0)!=Bars) ArrayResize(workLagRsi,Bars); i=Bars-i-1; instanceNo*=4;

   //
   //
   //
   //
   //
      
   workLagRsi[i][instanceNo+0] = (1.0 - gamma)*price                                                + gamma*workLagRsi[i-1][instanceNo+0];
	workLagRsi[i][instanceNo+1] = -gamma*workLagRsi[i][instanceNo+0] + workLagRsi[i-1][instanceNo+0] + gamma*workLagRsi[i-1][instanceNo+1];
	workLagRsi[i][instanceNo+2] = -gamma*workLagRsi[i][instanceNo+1] + workLagRsi[i-1][instanceNo+1] + gamma*workLagRsi[i-1][instanceNo+2];
	workLagRsi[i][instanceNo+3] = -gamma*workLagRsi[i][instanceNo+2] + workLagRsi[i-1][instanceNo+2] + gamma*workLagRsi[i-1][instanceNo+3];

		double CU = 0;
		double CD = 0;
      if (workLagRsi[i][instanceNo+0] >= workLagRsi[i][instanceNo+1])
			      CU += workLagRsi[i][instanceNo+0] - workLagRsi[i][instanceNo+1];
		else   	CD += workLagRsi[i][instanceNo+1] - workLagRsi[i][instanceNo+0];
      if (workLagRsi[i][instanceNo+1] >= workLagRsi[i][instanceNo+2])
			      CU += workLagRsi[i][instanceNo+1] - workLagRsi[i][instanceNo+2];
		else   	CD += workLagRsi[i][instanceNo+2] - workLagRsi[i][instanceNo+1];
      if (workLagRsi[i][instanceNo+2] >= workLagRsi[i][instanceNo+3])
			      CU += workLagRsi[i][instanceNo+2] - workLagRsi[i][instanceNo+3];
		else   	CD += workLagRsi[i][instanceNo+3] - workLagRsi[i][instanceNo+2];
		if (CU + CD != 0)
   			return(CU/(CU + CD));
      else  return(0           );
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][2];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}