//+------------------------------------------------------------------+
//|                                            CyberCycleCluster.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_plots   7
//--- plot EURUSD
#property indicator_label1  "EURUSD"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrLime
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot GBPUSD
#property indicator_label2  "GBPUSD"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrRed
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot Label1
#property indicator_label3  "AUDUSD"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrLightBlue
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- plot Label2
#property indicator_label4  "NZDUSD"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrChocolate
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//--- plot Label3
#property indicator_label5  "USDCAD"
#property indicator_type5   DRAW_LINE
#property indicator_color5  clrMaroon
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1
//--- plot Label4
#property indicator_label6  "USDCHF"
#property indicator_type6   DRAW_LINE
#property indicator_color6  clrDarkOrange
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1
//--- plot Label5
#property indicator_label7  "USDJPY"
#property indicator_type7   DRAW_LINE
#property indicator_color7  clrPurple
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1
//--- indicator buffers
double         EURUSDBuffer[];
double         GBPUSDBuffer[];
double         AUDUSDBuffer[];
double         NZDUSDBuffer[];
double         USDCADBuffer[];
double         USDCHFBuffer[];
double         USDJPYBuffer[];
string endfx, cpair1, cpair2, _cp;
bool noendfx = true;
int limit=0;
double Smooth[];
input int StartAtBar = 500;
input double InpAlpha = 0.07;
#define Price(i) ((iHigh(_cp,0,i)+iLow(_cp,0,i)+iClose(_cp,0,i)+iClose(_cp,0,i))/4.0)//Weighted
#define CLV(i) ((iClose(_cp,0,i)-iLow(_cp,0,i))-(iHigh(_cp,0,i)-iClose(_cp,0,i)))
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   endfx = StringSubstr(Symbol(), 6, StringLen(Symbol()) - 6);
   if (StringLen(endfx) == 0) noendfx = true;
   if (StringLen(endfx) > 0)  noendfx = false;
//--- indicator buffers mapping
   ArraySetAsSeries(Smooth,true);
   SetIndexBuffer(0,EURUSDBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,GBPUSDBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,AUDUSDBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,NZDUSDBuffer,INDICATOR_DATA);
   SetIndexBuffer(4,USDCADBuffer,INDICATOR_DATA);
   SetIndexBuffer(5,USDCHFBuffer,INDICATOR_DATA);
   SetIndexBuffer(6,USDJPYBuffer,INDICATOR_DATA);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(6,PLOT_EMPTY_VALUE,0.0);
   IndicatorDigits(8);
   SetIndexDrawBegin(0,500);
   SetIndexDrawBegin(1,500);
   SetIndexDrawBegin(2,500);
   SetIndexDrawBegin(3,500);
   SetIndexDrawBegin(4,500);
   SetIndexDrawBegin(5,500);
   SetIndexDrawBegin(6,500);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
    long tickCnt[1];
    int i;
    int ticks=CopyTickVolume(Symbol(), 0, 0, 1, tickCnt);
    if(ticks!=1) return(rates_total);
    if(prev_calculated==0 || tickCnt[0]==1)
    {
    //--- last counted bar will be recounted
//      int nLimit=rates_total-prev_calculated-1; // start index for calculations
      ArrayResize(Smooth,StartAtBar+1);

        _cp = StringConcatenate("EURUSD", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            EURUSDBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*EURUSDBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*EURUSDBuffer[i+2])+CLV(i);//
          }
          else {
            EURUSDBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("GBPUSD", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            GBPUSDBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*GBPUSDBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*GBPUSDBuffer[i+2])+CLV(i);//
          }
          else {
            GBPUSDBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("AUDUSD", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            AUDUSDBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*AUDUSDBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*AUDUSDBuffer[i+2])+CLV(i);//
          }
          else {
            AUDUSDBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("NZDUSD", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            NZDUSDBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*NZDUSDBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*NZDUSDBuffer[i+2])+CLV(i);//
          }
          else {
            NZDUSDBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("USDCAD", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            USDCADBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*USDCADBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*USDCADBuffer[i+2])+CLV(i);//
          }
          else {
            USDCADBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("USDCHF", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=(Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0;
          if (i < StartAtBar - 7) {
            USDCHFBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*USDCHFBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*USDCHFBuffer[i+2])+CLV(i);//
          }
          else {
            USDCHFBuffer[i]=(Price(i)-2.0*Price(i+1)+Price(i+2))/4.0;
          }
        }
        _cp = StringConcatenate("USDJPY", endfx);
        for(i=StartAtBar; i>=0 && !IsStopped(); i--) {
          Smooth[i]=((Price(i)+2*Price(i+1)+2*Price(i+2)+Price(i+3))/6.0)/100;
          if (i < StartAtBar - 7) {
            USDJPYBuffer[i]=((1.0-0.5*InpAlpha) *(1.0-0.5*InpAlpha) *(Smooth[i]-2.0*Smooth[i+1]+Smooth[i+2])
                     +2.0*(1.0-InpAlpha)*USDJPYBuffer[i+1]-(1.0-InpAlpha)*(1.0-InpAlpha)*USDJPYBuffer[i+2])+(CLV(i)/100);//
          }
          else {
            USDJPYBuffer[i]=((Price(i)-2.0*Price(i+1)+Price(i+2))/4.0)/100;//
          }
        }
    }
    //--- return value of prev_calculated for next call
    return(rates_total);
  }
//+------------------------------------------------------------------+
