//+------------------------------------------------------------------+
//|                                                 mama channel.mq4 |
//|                                                                  |
//|                  mama by Mladen ma squize by Kalenzo and Mladen  |
//|                                                  mod by mrtools  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  DeepPink
#property indicator_color3  DodgerBlue
#property indicator_color4  DeepPink
#property indicator_color5  Gold
#property indicator_color6  Gold
#property indicator_width5  8
#property indicator_width6  8

//
//
//
//
//

extern double FastLimit        = 0.5;
extern double SlowLimit        = 0.05;
extern int    Price            = PRICE_MEDIAN;
extern double MaThreshold      = 5;
extern bool   UseAtr           = true;
extern bool   ShowSqz          = true;
extern int    AtrPeriod        = 50;
extern double Multiplier       = 0.4;
extern bool   ShowMaLines      = false;

extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";
extern int    arrowSize        = 2;

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double mama[];
double fama[];
double UpEnv[];
double DnEnv[];
double trend[];
double alphas[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);  
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,225);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,226);
   SetIndexBuffer(2,mama);
   SetIndexBuffer(3,fama);
   SetIndexBuffer(4,UpEnv); 
   SetIndexBuffer(5,DnEnv); 
   SetIndexBuffer(6,trend); 
 
   
   if (ShowMaLines)
   {
   SetIndexStyle(2,DRAW_LINE);  
   SetIndexStyle(3,DRAW_LINE);  
   }
   
   else
   {
   SetIndexStyle(2,DRAW_NONE);
   SetIndexStyle(3,DRAW_NONE);
   }
   
   IndicatorShortName("Mama channel ("+DoubleToStr(FastLimit,2)+","+DoubleToStr(SlowLimit,2)+")");
return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][14];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _phase     4
#define _Q1        5
#define _I1        6
#define _JI        7
#define _JQ        8
#define _Q2        9
#define _I2       10
#define _Re       11
#define _Im       12
#define _sa       13

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

int start()
{
   double rad2degree = 180.0/Pi;
   int    i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_price]     = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      work[r][_smooth]    = (4.0*work[r][_price]+3.0*work[r-1][_price]+2.0*work[r-2][_price]+work[r-3][_price])/10.0;
      work[r][_detrender] = calcComp(r,_smooth);
      work[r][_Q1]        = calcComp(r,_detrender);
      work[r][_I1]        = work[r-3][_detrender];
      work[r][_JI]        = calcComp(r,_I1);
      work[r][_JQ]        = calcComp(r,_Q1);
      
      //
      //
      //
      //
      //
      
      work[r][_I2] = 0.2*(work[r][_I1]-work[r][_JQ])                                 + 0.8*work[r-1][_I2];
      work[r][_Q2] = 0.2*(work[r][_Q1]+work[r][_JI])                                 + 0.8*work[r-1][_Q2];
      work[r][_Re] = 0.2*(work[r][_I2]*work[r-1][_I2] + work[r][_Q2]*work[r-1][_Q2]) + 0.8*work[r-1][_Re];
      work[r][_Im] = 0.2*(work[r][_I2]*work[r-1][_Q2] - work[r][_Q2]*work[r-1][_I2]) + 0.8*work[r-1][_Im];
      
      if (work[r][_Re]!= 0 && work[r][_Im]!=0) 
          work[r][_period] = 360.0/(MathArctan(work[r][_Im]/work[r][_Re])*rad2degree);
          work[r][_period] = MathMin(work[r][_period],1.50*work[r-1][_period]);
          work[r][_period] = MathMax(work[r][_period],0.67*work[r-1][_period]);
          work[r][_period] = MathMin(MathMax(work[r][_period],6),50);
          work[r][_period] = 0.2*work[r][_period]+0.8*work[r-1][_period];
      
      //
      //
      //
      //
      //
      
      if( work[r][_I1] != 0) work[r][_phase] = MathArctan(work[r][_Q1]/work[r][_I1])*rad2degree;
                  double DeltaPhase = MathMax(work[r-1][_phase]-work[r][_phase],1);
                  double Alpha      = MathMax(MathMin(FastLimit/DeltaPhase,FastLimit),SlowLimit);
      work[r][_sa] = Alpha;
	
      //
      //
      //
      //
      //

      mama[i]     =     work[r][_sa]*work[r][_price] + (1.0-    work[r][_sa])*mama[i+1];
      fama[i]     = 0.5*work[r][_sa]*mama[i]         + (1.0-0.5*work[r][_sa])*fama[i+1];
      double diff = MathAbs(mama[i]-fama[i])/Point;
      
      //
      //
      //
      //
      //
      
      if (UseAtr)       
        double   distance = iNoLagMa(MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]),AtrPeriod,alphas,0,i)*Multiplier/Point;
        else     distance = MaThreshold;
      
      if (diff < distance) 
      {
        if (ShowSqz) 
        {
           UpEnv[i] = fama[i] + distance * Point;
           DnEnv[i] = fama[i] - distance * Point;
        } 
        else 
        {
           mama[i] = mama[i] - diff * 0.5;
           fama[i] = mama[i] - diff * 0.5;
        }
  
       }
      
        trend[i] = trend[i+1];
          if (mama[i]>fama[i]) trend[i] = 1;
          if (mama[i]<fama[i]) trend[i] =-1;
          
          //
          //
          //
          //
          //
      
          CrossUp[i] = EMPTY_VALUE;
          CrossDn[i] = EMPTY_VALUE;
          if (trend[i]!= trend[i+1])
          if (trend[i] == 1)
                CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
          else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
          }
          
          //
          //
          //
          //
          //
      
          if (alertsOn)
          {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
                doAlert("Buy");
          else  doAlert("Sell");       
   }

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double calcComp(int r, int from)
{
   return((0.0962*work[r  ][from] + 
           0.5769*work[r-2][from] - 
           0.5769*work[r-4][from] - 
           0.0962*work[r-6][from]) * (0.075*work[r-1][_period] + 0.54));
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," mama channel ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," mama channel "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double values[][3];
double prices[][1];

#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}

